package com.l2jfrozen.gameserver.handler.voicedcommandhandlers;

import java.security.MessageDigest;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.StringTokenizer;
import com.l2jfrozen.gameserver.handler.IVoicedCommandHandler;
import com.l2jfrozen.gameserver.model.actor.instance.L2PcInstance;
import com.l2jfrozen.util.database.L2DatabaseFactory;
import com.l2jfrozen.crypt.Base64;

public class ChangePassword implements IVoicedCommandHandler
{
	private static final String[] _voicedCommands = { "changepassword" };

	public boolean useVoicedCommand(String command, L2PcInstance activeChar, String target)
	{
		if ((command.equalsIgnoreCase("changepassword")) && (target != null))
		{
			StringTokenizer st = new StringTokenizer(target);
			try
			{
				String curpass = null; String newpass = null; String repeatnewpass = null;

				if (st.hasMoreTokens()) {
					curpass = st.nextToken();
				}
				if (st.hasMoreTokens()) {
					newpass = st.nextToken();
				}
				if (st.hasMoreTokens()) {
					repeatnewpass = st.nextToken();
				}
				if ((curpass != null) && (newpass != null) && (repeatnewpass != null))
				{
					if (!newpass.equals(repeatnewpass))
					{
						activeChar.sendMessage("Введенные новые пароли не совпадают!");
						return false;
					}
					if (newpass.length() < 3)
					{
						activeChar.sendMessage("Новый пароль короче 3 символов! Пожалуйста, попробуйте ввести более длинный.");
						return false;
					}
					if (newpass.length() > 30)
					{
						activeChar.sendMessage("Новый пароль длиннее 30 символов! Пожалуйста, попробуйте ввести более короткий.");
						return false;
					}

					MessageDigest md = MessageDigest.getInstance("SHA");

					byte[] raw = curpass.getBytes("UTF-8");
					raw = md.digest(raw);
					String curpassEnc = Base64.encodeBytes(raw);
					String pass = null;
					int passUpdated = 0;

					Connection con = null;
					con = L2DatabaseFactory.getInstance().getConnection();
					PreparedStatement statement = con.prepareStatement("SELECT password FROM accounts WHERE login=?");
					statement.setString(1, activeChar.getAccountName());
					ResultSet rset = statement.executeQuery();

					if (rset.next())
					{
						pass = rset.getString("password");
					}

					rset.close();
					statement.close();

					if (curpassEnc.equals(pass))
					{
						byte[] password = newpass.getBytes("UTF-8");
						password = md.digest(password);

						PreparedStatement ps = con.prepareStatement("UPDATE accounts SET password=? WHERE login=?");
						ps.setString(1, Base64.encodeBytes(password));
						ps.setString(2, activeChar.getAccountName());
						passUpdated = ps.executeUpdate();
						con.close();

						if (passUpdated > 0)
						{
							activeChar.sendMessage("Вы успешно изменили пароль!");
						}
						else
						{
							activeChar.sendMessage("Смена пароля не удалась!");
						}
					}
					else
					{
						activeChar.sendMessage("СтарыйПароль не совпадает с вашим текущим.");
						return false;
					}
				}
				else
				{
					activeChar.sendMessage("Неправильный формат запроса! Формат: .changepassword СтарыйПароль НовыйПароль НовыйПароль");
					return false;
				}
			}
			catch (Exception e)
			{
				activeChar.sendMessage("Возникла проблема при смене пароля!");
			}
		}
		else
		{
			activeChar.sendMessage("Чтобы изменить свой текущий пароль, вы должны ввести команду в следующем формате (без скобок []): [.changepassword СтарыйПароль НовыйПароль НовыйПароль]. Вы также должны знать, что пароль чувствителен к регистру.");
			return false;
		}
		return true;
	}

	public String[] getVoicedCommandList()
	{
		return _voicedCommands;
	}
}